<?php

namespace Cronard;

use Notes\Cronard\TaskFetcher;

trait CronardTrait {

    public array $crontabs = [];

    public function launch(array $variables) : void
    {
        $cronard = new Cronard();

        foreach($this->crontabs as $tab => $callback) {
            $cronard->setTab($tab);
            $cronard->run(array_merge($this->variables, $variables), $callback);
        }
    }

    public function fromFile(string $filepath) : self
    {
        if ( ! file_exists($filepath) ) {
            throw new \RuntimeException("Given crontab file cannot be found. There could also be a problem at permission level.");
        }

        $this->crontabs = array_merge($this->crontabs, include($filepath));
        
        return $this;
    }

    public function fromAnnotations(TaskFetcher $fetcher) : self
    {
        $tasks = [];

       /* foreach($fetcher->compile() as $task) {
            dump($task);
        }

        $this->crontabs = array_merge($this->crontabs, $tasks);
*/
        return $this;
    }
}
